> ## Documentation Index
> Fetch the complete documentation index at: https://docs.anglpay.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List transaction events

This endpoint requires the `transactions.read` scope.


## OpenAPI

````yaml openapi.speakeasy.json GET /transactions/{transaction_id}/events
openapi: 3.0.0
info:
  title: Gr4vy API
  version: 1.1.0-beta
  contact:
    name: Gr4vy Support
    email: code@gr4vy.com
    url: https://gr4vy.com
  termsOfService: https://gr4vy.com
  license:
    name: MIT
    url: https://raw.githubusercontent.com/gr4vy/gr4vy-openapi/main/LICENSE
  description: |-
    Welcome to the Gr4vy API reference documentation.
    Our API is still very much a work in product and subject to change.
servers:
  - url: https://api.sandbox.{id}.gr4vy.app
    x-speakeasy-server-id: sandbox
    variables:
      id:
        default: example
        description: The subdomain for your Gr4vy instance.
  - url: https://api.{id}.gr4vy.app
    x-speakeasy-server-id: production
    variables:
      id:
        default: example
        description: The subdomain for your Gr4vy instance.
security:
  - bearerAuth: []
tags:
  - name: Account Updater
    description: >-
      An Account Updater is a service provided by credit card issuers

      (such as banks and financial institutions) to merchants who accept

      recurring payments from customers. Its primary purpose is to help

      merchants maintain accurate and up-to-date payment information for

      their customers' credit or debit card accounts.


      In Gr4vy, the Account Updater service is provided in an on-demand

      and asynchronous fashion:


      1. A merchant requests an update for a set of stored cards.

      2. A request is submitted to a third-party service.

      3. When results are ready, new card details are stored and left in
      standby.

      4. Card details are updated when it gets determined that the original card
         is no longer valid (e.g. has expired).
  - name: Anti-Fraud Services
    description: >-
      In Gr4vy, an anti-fraud service represents a configured anti-fraud service

      provider (`Sift`, `CyberSource`, etc). This third-party services will be

      used to screen transactions to determine the risk and prevents chargebacks

      and fraudulent transactions.


      The anti-fraud services API can be used to:


      * Provide Gr4vy with the API credentials for an anti-fraud service
      provider.

      * Set a display name for a anti-fraud provider.

      * Map anti-fraud service decisions to Gr4vy internal decisions.
    x-internal: true
  - name: Anti Fraud Service Definitions
    description: >-
      Anti fraud service definitions describe the fields required for a anti
      fraud

      service to be configured.
  - name: API Key Pairs
    description: >-
      In Gr4vy, an API key pair is used to sign and validate JSON Web Tokens
      (JWT).

      JWTs are used as a HTTP `bearer` token to authenticate to the API. For
      more

      information please visit our [in-depth
      authentication](/guides/authentication)

      guide.
    x-internal: true
  - name: API Logs
    description: >-
      API Logs provide an historic of 4XX and 5XX errors that happened in the
      API

      in the last 24 hours with a 250 result limit.
    x-internal: true
  - name: Apple Pay Certificates
    description: >-
      Apple Pay payment processing certificates are used by Apple to encrypt
      Apple

      Pay tokens. You must register and upload an Apple Pay payment processing

      certificate if you wish to use Apple Pay with Gr4vy's mobile SDKs.


      The Apple Pay certificates API can be used to:


      * Start a new Apple Pay certificate registration, providing you with a

      Certificate Signing Request (CSR).

      * Update the Apple Pay certificate record with the certificate received
      from

      Apple after creating a new payment processing certificate on your Apple

      Developer console and uploading a CSR.

      * List all Apple Pay certificates.
    x-internal: true
  - name: Audit Logs
    description: >-
      Audit Logs provide an historic record of changes made to your Gr4vy
      instance.
  - name: Buyers
    description: >-
      In Gr4vy, a buyer represents your customer, the shopper who's performing

      a checkout and making a purchase.


      A buyer can be used by you to:


      * Display a human readable name (`display_name`) for a buyer in the Gr4vy

      admin panel

      * Associate multiple stored payment methods with a single user

      * Initialize **Gr4vy Embed** with the buyer ID, automatically displaying
      the
        buyer's previously stored payment methods, allowing for faster checkout.
  - name: Card Details
    description: Endpoints to retrieve details of a card by utilising a BIN lookup table.
    x-internal: true
  - name: Card Scheme Definitions
    description: Card Scheme definitions provide display information to a card scheme.
  - name: Connections
    description: |-
      Endpoints to retrieve details of configured connections such as payment
      services, digital wallets, and anti-fraud services.
    x-internal: true
  - name: Connection Definitions
    description: |-
      Endpoints to retrieve details of various connections such as payment
      services, digital wallets, and anti-fraud services.
    x-internal: true
  - name: Checkout Sessions
    description: |-
      A Checkout Session represents the session of a user as they progress
      through an online checkout.
  - name: Digital Wallets
    description: |-
      In Gr4vy, a digital wallet represents a way for a buyer to pay using
      card details already stored on their device via a digital wallet service
      such as Apple Pay or Google Pay. The buyer will not have to fill in their
      card details on checkout.

      The digital wallets API can be used to:

      * Register with a digital wallet provider.
      * List digital wallets currently registered.
  - name: Gift Cards
    description: >-
      In Gr4vy, a gift card represents a stored value card that can be used to
      pay for

      a transaction.
  - name: Gift Card Services
    description: >-
      In Gr4vy, a gift card service represents a configured provider for
      processing

      gift cards.
  - name: Gift Card Service Definitions
    description: |-
      Gift card service definitions describe the fields required for a gift
      card service to be configured.
  - name: Health Dashboard
    description: Endpoints to retrieve the data used for the Health Dashboard.
    x-internal: true
  - name: Merchant Accounts
    description: |-
      In Gr4vy, a merchant account represents an individual merchant in an
      instance. Each instance has one or more merchant accounts, and each
      merchant account has its own connections, Flow rules, transactions, and
      more.
  - name: Metrics Explorer
    description: Endpoints to retrieve the data used for the Metrics Explorer.
    x-internal: true
  - name: Payment Methods
    description: |-
      In Gr4vy, a payment method represents a way in which a payment can be
      processed, for example a card, a PayPal account, or a bank account.

      The payment method API can be used to:

      * List all the available payment methods
      * Filter the available payment method for a buyer in a specific currency
      and country.
      * Store (also known as vault) a payment method for a buyer.
      * Fetch all previously stored payment methods for a buyer.
  - name: Payment Method Definitions
    description: >-
      Payment Method definitions provide display information to a payment
      method.
  - name: Payment Options
    description: |-
      In Gr4vy, a payment option represents a list of methods (card, PayPal,
      etc) that are available for a given locale.

      The payment options API can be used to:

      * Determine what types of payments can be processed in a specific locale.
      * Display a list options to a buyer to choose from.
  - name: Payment Service Definitions
    description: |-
      Payment service definitions describe the fields required for a payment
      service to be configured.
  - name: Payment Services
    description: |-
      In Gr4vy, a payment service represents a configured payment provider
      (Stripe, PayPal, Adyen, etc) for a specific payment type (card, bitcoin,
      etc)

      The payment services API can be used to:

      * Provide Gr4vy with the payment credentials for a payment provider.
      * Set a display name for a payment provider.
  - name: Payouts
    description: |-
      Payouts allow a merchant to send money from one of their own accounts to a
      third party.
  - name: Payment Links
    description: >-
      In Gr4vy, payment links allow a merchant to generate a link, send it to a

      customer via email, SMS, etc, and then have the customer pay without the
      need

      for the merchant hosting their own checkout.
  - name: Vault Forward Definitions
    description: >-
      Vault Forward definitions describe a third party service that has been
      vetted

      to receive requests containing PCI data.
  - name: Vault Forward Configurations
    description: |-
      A Vault Forward Configuration represents a third party service that is
      currently enabled to send requests containing PCI data.
  - name: Vault Forward
    description: |-
      Vault Forwarding is a way to perform requests where, provided a template,
      Gr4vy will evaluate it to inject PCI data and forward it to third party
      services that have been vetted to receive such data.
  - name: Reports
    description: |-
      In Gr4vy, a report represents the configuration details to extract or
      dump a set of data into a downloadable CSV file. The data extracted
      by a report is configured via the reports API where you can specify:

      * Which fields should be in the dataset.
      * How the dataset should be sorted.
      * How the dataset should be filtered.

      Once a report is created, it may be executed on a one-off or recurring
      basis. One-off reports are executed only once shortly after the report
      is created, while recurring reports are executed periodically based on
      its configured frequency, e.g. weekly or monthly.

      During a report execution, the data is extracted and loaded into
      a CSV file according to the report's configuration. The resulting file
      may then be downloaded.

      The reports API can be used to:

      * Create and configure new reports.
      * List all reports.
      * View the configuration details of a report.
      * List a report's executions.
      * Reconfigure an existing report.
      * Generate a temporary URL to download the result of a report execution
      in CSV format.
  - name: Sessions
    description: |-
      The sessions APIs are used to facilitate user authentication for the Gr4vy
      dashboard.
    x-internal: true
  - name: Transactions
    description: >-
      In Gr4vy, a transaction represents a payment in any state, either before
      it

      is authorized, once it is captured, or after it has been refunded.


      The transactions API can be used to:


      - Authorize, capture, and store cards.

      - Authorize, capture, and store alternative payment methods like PayPal.

      - Refund, void, and otherwise cancel existing transactions.
  - name: Users
    description: |-
      In Gr4vy, a user represents an employee of the merchant with access to the
      dashboard.
    x-internal: true
  - name: Webhooks
    description: |-
      Endpoints related to webhooks to integrate Gr4vy with payment services
      webhooks functionality.
    x-internal: true
  - name: Flow
    description: >-
      In Gr4vy, a rule can be created that triggers actions anywhere in the
      payment flow.
    x-internal: true
  - name: Roles
    description: >-
      In Gr4vy, users can be granted access to specific types of resources and
      permissions

      to perform certain actions by being assigned one or more roles.
  - name: Tokens
    description: Endpoints related to the Gr4vy tokenization service.
  - name: Webhook subscriptions
    description: >-
      Endpoints related to the management of subscriptions for endpoints to
      receive webhooks.
paths:
  /transactions/{transaction_id}/events:
    parameters:
      - schema:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
        name: transaction_id
        in: path
        required: true
        description: The ID for the transaction to get the information for.
    get:
      tags:
        - Transactions
      summary: List events for transaction
      description: Get a list of events related to processing a transaction.
      operationId: get-transaction-events
      parameters:
        - schema:
            type: string
            format: ''
            example: ZXhhbXBsZTE
          in: query
          name: cursor
          description: >-
            A cursor that identifies the page of results to return. This is used
            to

            paginate the results of this API.


            For the first page of results, this parameter can be left out.

            For additional pages, use the value returned by the API in

            the `next_cursor` field. Similarly the `previous_cursor` can be used
            to

            reverse backwards in the list.
        - schema:
            type: integer
            default: 100
            example: 1
            minimum: 1
            maximum: 500
            format: int32
          in: query
          name: limit
          description: Defines the maximum number of items to return for this request.
      responses:
        '200':
          description: Returns a collection of transaction history events.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TransactionHistoryEvents'
        '401':
          description: Returns an error if no valid authentication was provided.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error401Unauthorized'
        '404':
          description: >-
            Returns an error if the resource can not be found or has not yet
            been created.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error404NotFound'
components:
  schemas:
    TransactionHistoryEvents:
      title: Transaction History Events
      description: A list of transaction history events.
      type: object
      x-tags:
        - Transactions
      properties:
        items:
          type: array
          description: A list of events related to processing a transaction.
          items:
            x-model-name: TransactionHistoryEvent
            oneOf:
              - $ref: '#/components/schemas/BINLookupRequest'
              - $ref: '#/components/schemas/ThreeDSecureAuthenticationRequestEvent'
              - $ref: '#/components/schemas/ThreeDSecureSuccessEvent'
              - $ref: '#/components/schemas/ThreeDSecureRequestErrorEvent'
              - $ref: '#/components/schemas/ThreeDSecurePreparationRequestEvent'
              - $ref: '#/components/schemas/ThreeDSecureResultRequestEvent'
              - $ref: '#/components/schemas/AntiFraudDecisionEvent'
              - $ref: '#/components/schemas/AntiFraudDecisionErrorEvent'
              - $ref: '#/components/schemas/AntiFraudDecisionSkippedEvent'
              - $ref: '#/components/schemas/AntiFraudDecisionUpdateEvent'
              - $ref: '#/components/schemas/AntiFraudDecisionUpdateErrorEvent'
              - $ref: '#/components/schemas/AntiFraudTransactionStatusUpdateEvent'
              - $ref: >-
                  #/components/schemas/AntiFraudTransactionStatusUpdateErrorEvent
              - $ref: '#/components/schemas/AntiFraudWebhookEvent'
              - $ref: '#/components/schemas/DigitalWalletApplePayTokenDecrypted'
              - $ref: '#/components/schemas/DigitalWalletClickToPayTokenDecrypted'
              - $ref: '#/components/schemas/DigitalWalletGooglePayTokenDecrypted'
              - $ref: '#/components/schemas/GiftCardRedemptionFailed'
              - $ref: '#/components/schemas/GiftCardRedemptionSucceeded'
              - $ref: '#/components/schemas/GiftCardRefundFailed'
              - $ref: '#/components/schemas/GiftCardRefundSucceeded'
              - $ref: '#/components/schemas/NetworkTokenCryptogramProvisionFailed'
              - $ref: '#/components/schemas/NetworkTokenCryptogramProvisionSucceeded'
              - $ref: '#/components/schemas/NetworkTokenProvisionFailed'
              - $ref: '#/components/schemas/NetworkTokenProvisionSucceeded'
              - $ref: >-
                  #/components/schemas/PaymentConnectorResponseTransactionAuthorizationSucceededEvent
              - $ref: >-
                  #/components/schemas/PaymentConnectorResponseTransactionDeclinedEvent
              - $ref: >-
                  #/components/schemas/PaymentConnectorResponseTransactionAuthorizationFailedEvent
              - $ref: >-
                  #/components/schemas/PaymentConnectorResponseTransactionCaptureDeclinedEvent
              - $ref: >-
                  #/components/schemas/PaymentConnectorResponseTransactionCaptureFailedEvent
              - $ref: >-
                  #/components/schemas/PaymentConnectorResponseTransactionCaptureSucceededEvent
              - $ref: '#/components/schemas/PaymentConnectorResponseTransactionSync'
              - $ref: >-
                  #/components/schemas/PaymentConnectorResponseTransactionVoidDeclinedEvent
              - $ref: >-
                  #/components/schemas/PaymentConnectorResponseTransactionVoidFailedEvent
              - $ref: >-
                  #/components/schemas/PaymentConnectorResponseTransactionVoidSucceededEvent
              - $ref: >-
                  #/components/schemas/PaymentConnectorExternalTransactionRequest
              - $ref: '#/components/schemas/PaymentConnectorReportTransactionSettled'
              - $ref: '#/components/schemas/RealTimeAccountUpdate'
              - $ref: '#/components/schemas/TransactionAPIRequest'
              - $ref: '#/components/schemas/TransactionAPIResponse'
        limit:
          type: integer
          description: >-
            The limit applied to request. This represents the number of items
            that are at

            maximum returned by this request.
          format: int32
          minimum: 1
          maximum: 500
          example: 1
          default: 20
        next_cursor:
          type: string
          description: >-
            The cursor that represents the next page of results. Use the
            `cursor` query

            parameter to fetch this page of items.
          example: ZXhhbXBsZTE
          nullable: true
          minLength: 1
          maxLength: 1000
        previous_cursor:
          type: string
          description: >-
            The cursor that represents the next page of results. Use the
            `cursor` query

            parameter to fetch this page of items.
          example: null
          nullable: true
          minLength: 1
          maxLength: 1000
    Error401Unauthorized:
      title: Unauthorized Error
      type: object
      description: Unauthorized Error (HTTP 401).
      x-tags:
        - Errors
      properties:
        type:
          type: string
          description: '`error`.'
          enum:
            - error
          example: error
        code:
          type: string
          description: '`unauthorized`.'
          example: unauthorized
          enum:
            - unauthorized
        status:
          type: integer
          description: '`401`.'
          example: 401
          enum:
            - 401
        message:
          type: string
          description: No valid API authentication found.
          example: No valid API authentication found
          enum:
            - No valid API authentication found
        details:
          type: array
          description: >-
            A list of detail objects that further clarify the reason for the
            error.

            Not every error supports more detail.
          example: []
          items:
            $ref: '#/components/schemas/ErrorDetail'
    Error404NotFound:
      title: Not Found Error
      type: object
      description: Not Found Error (HTTP 404).
      x-tags:
        - Errors
      properties:
        type:
          type: string
          description: '`error`.'
          enum:
            - error
          example: error
        code:
          type: string
          description: The reason code for the error.
          example: not_found
          enum:
            - not_found
            - pending_creation
        status:
          type: integer
          description: '`404`.'
          example: 404
          enum:
            - 404
        message:
          type: string
          description: The human readable reason for the error.
          example: The resource could not be found
        details:
          type: array
          description: >-
            A list of detail objects that further clarify the reason for the
            error.

            Not every error supports more detail.
          example: []
          items:
            $ref: '#/components/schemas/ErrorDetail'
    BINLookupRequest:
      title: BIN Lookup Request
      type: object
      description: The result and raw data for a card BIN lookup.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: The name of this resource. Is always `bin-lookup-request`.
          example: bin-lookup-request
          enum:
            - bin-lookup-request
        created_at:
          type: string
          description: The date and time when this transaction was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: BIN lookup request context.
          properties:
            response:
              type: string
              nullable: true
              description: The response body received from the `url`.
              example: '{}'
            response_status_code:
              type: integer
              description: The response status code received from the `url`.
              example: 200
            success:
              type: boolean
              description: Whether the BIN lookup was successful or not.
            bin:
              type: string
              nullable: true
              description: The value used to lookup BIN details.
            instrument:
              type: string
              nullable: true
              description: The instrument type used to lookup BIN details.
              example: pan
            type:
              type: string
              nullable: true
              description: >-
                The type of card, i.e. credit or debit, from the lookup
                response.
            scheme:
              nullable: true
              description: The card scheme result from the lookup response.
              type: string
              example: visa
              enum:
                - accel
                - amex
                - bancontact
                - carte-bancaire
                - cirrus
                - culiance
                - dankort
                - diners-club
                - discover
                - eftpos-australia
                - elo
                - hipercard
                - jcb
                - maestro
                - mastercard
                - mir
                - nyce
                - other
                - pulse
                - rupay
                - star
                - uatp
                - unionpay
                - visa
                - null
            additional_schemes:
              type: array
              items:
                type: string
                example: visa
                enum:
                  - accel
                  - amex
                  - bancontact
                  - carte-bancaire
                  - cirrus
                  - culiance
                  - dankort
                  - diners-club
                  - discover
                  - eftpos-australia
                  - elo
                  - hipercard
                  - jcb
                  - maestro
                  - mastercard
                  - mir
                  - nyce
                  - other
                  - pulse
                  - rupay
                  - star
                  - uatp
                  - unionpay
                  - visa
                  - null
              nullable: true
              description: The card additional schemes from the lookup response.
            country_code:
              type: string
              nullable: true
              description: The card country code result from the lookup response.
            supports_network_tokens:
              type: boolean
              nullable: true
              description: >-
                Whether the issuing bank supports network tokenization for this
                card.
    ThreeDSecureAuthenticationRequestEvent:
      title: 3DS - Authentication
      type: object
      description: The result and raw data for a 3DS authorization call.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: >-
            The name of this resource. Is always
            `three-d-secure-authentication-request`.
          example: three-d-secure-authentication-request
          enum:
            - three-d-secure-authentication-request
        created_at:
          type: string
          description: The date and time when this transaction was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: 3DS authentication context.
          properties:
            url:
              type: string
              description: The URL that was called for this request.
              example: https://3dserver.example/auth
            request:
              type: string
              description: The request body sent to the `url`.
              example: '{}'
            response:
              type: string
              description: The response body received from the `url`.
              example: '{}'
            response_status_code:
              type: integer
              description: The response status code received from the `url`.
              example: 200
            cavv:
              type: string
              description: The 3DS CAVV value parsed from the `response`.
              example: +9YDsoSIbiEgO+PFMdgGSF17Uqk=
            eci:
              type: string
              description: The 3DS ECI value parsed from the `response`.
              example: '05'
            directory_response:
              type: string
              description: The `transStatus` parsed from the `response`.
              example: C
            directory_transaction_id:
              type: string
              description: The `dsTransID` parsed from the `response`.
              example: 8875884a-ac2f-42cb-b3f0-09b3ea3c0042
            version:
              type: string
              description: The version of 3DS used.
              example: 2.2.0
    ThreeDSecureSuccessEvent:
      title: 3DS - Authentication (Deprecated)
      type: object
      description: Details related to 3DS processing.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: The name of this resource. Is always `three-d-secure-success`.
          example: three-d-secure-success
          enum:
            - three-d-secure-success
        created_at:
          type: string
          description: The date and time when this transaction was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: 3DS context.
          properties:
            eci:
              type: string
              pattern: ^0?\d$
              minLength: 1
              maxLength: 2
              description: The ecommerce indicator for the 3DS transaction.
              example: '05'
            cavv:
              type: string
              description: The cardholder authentication value or AAV.
              example: 3q2+78r+ur7erb7vyv66vv8=
            version:
              type: string
              pattern: ^[1-2].?[\d+.?]{0,3}$
              description: The version of 3-D Secure that was used.
            directory_response:
              type: string
              maxLength: 1
              description: >-
                For 3-D Secure version 1, the enrolment response. For 3-D Secure
                version , the transaction status from the `ARes`.
              example: C
            authentication_response:
              type: string
              nullable: true
              maxLength: 1
              description: >-
                The transaction status from the challenge result (not required
                for frictionless).
              example: 'Y'
            directory_transaction_id:
              type: string
              description: The transaction identifier.
              example: c4e59ceb-a382-4d6a-bc87-385d591fa09d
              nullable: true
            cavv_algorithm:
              type: string
              nullable: true
              maxLength: 1
              description: The CAVV Algorithm used.
            method:
              type: string
              nullable: true
              description: The method used for 3DS authentication for this transaction.
              enum:
                - challenge
                - frictionless
    ThreeDSecureRequestErrorEvent:
      title: 3DS - Error
      type: object
      description: Error details for a failed 3DS call.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: The name of this resource. Is always `three-d-secure-request-error`.
          example: three-d-secure-request-error
          enum:
            - three-d-secure-request-error
        created_at:
          type: string
          description: The date and time when this transaction was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: 3DS post-authentication context.
          properties:
            url:
              type: string
              description: The URL that was called for this request.
              example: https://3dserver.example/auth
            reason:
              type: string
              description: The reason for the error.
              example: TIMEOUT
    ThreeDSecurePreparationRequestEvent:
      title: 3DS - Pre-authentication
      type: object
      description: The result and raw data for a 3DS pre-authorization call.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: >-
            The name of this resource. Is always
            `three-d-secure-preparation-request`.
          example: three-d-secure-preparation-request
          enum:
            - three-d-secure-preparation-request
        created_at:
          type: string
          description: The date and time when this transaction was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: 3DS pre-authentication context.
          properties:
            url:
              type: string
              description: The URL that was called for this request.
              example: https://3dserver.example/auth
            request:
              type: string
              description: The request body sent to the `url`.
              example: '{}'
            response:
              type: string
              description: The response body received from the `url`.
              example: '{}'
            response_status_code:
              type: integer
              description: The response status code received from the `url`.
              example: 200
            is_enrolled:
              type: boolean
              description: If the card is enrolled for 3DS.
              example: true
            version:
              type: string
              description: The version of 3DS extracted from the `response.
              example: 2.2.0
    ThreeDSecureResultRequestEvent:
      title: 3DS - Post-authentication
      type: object
      description: The result and raw data for a 3DS post-authorization call.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: >-
            The name of this resource. Is always
            `three-d-secure-result-request`.
          example: three-d-secure-result-request
          enum:
            - three-d-secure-result-request
        created_at:
          type: string
          description: The date and time when this transaction was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: 3DS post-authentication context.
          properties:
            url:
              type: string
              description: The URL that was called for this request.
              example: https://3dserver.example/auth
            request:
              type: string
              description: The request body sent to the `url`.
              example: '{}'
            response:
              type: string
              description: The response body received from the `url`.
              example: '{}'
            response_status_code:
              type: integer
              description: The response status code received from the `url`.
              example: 200
            cavv:
              type: string
              description: The 3DS CAVV value parsed from the `response`.
              example: +9YDsoSIbiEgO+PFMdgGSF17Uqk=
            eci:
              type: string
              description: The 3DS ECI value parsed from the `response`.
              example: '05'
            authentication_response:
              type: string
              description: The `transStatus` parsed from the post-authorization `response`.
              example: C
            directory_response:
              type: string
              description: The `transStatus` parsed from the authorization `response`.
              example: C
            directory_transaction_id:
              type: string
              description: The `dsTransID` parsed from the `response`.
              example: 8875884a-ac2f-42cb-b3f0-09b3ea3c0042
            is_challenge_cancelled:
              type: boolean
              description: Flag to indicate whether the buyer cancelled 3DS authentication.
              example: false
    AntiFraudDecisionEvent:
      title: Anti-fraud - Decision
      type: object
      description: >-
        This event logs the request and response details of HTTP calls made to
        an anti-fraud provider.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: The name of this resource. Is always `anti-fraud-decision`.
          example: anti-fraud-decision
          enum:
            - anti-fraud-decision
        created_at:
          type: string
          description: The date and time when this transaction was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            anti_fraud_service_id:
              type: string
              format: uuid
              description: The unique ID of the anti-fraud service used.
            anti_fraud_service_name:
              type: string
              description: The name of the anti-fraud service used.
            anti_fraud_service_definition_id:
              type: string
              description: The anti-fraud service definition used.
            anti_fraud_service_check_id:
              type: string
              description: The external ID of the decision.
              example: decision-1234
            request:
              type: string
              description: The HTTP body sent to fetch a decision.
            response:
              type: string
              description: The HTTP body received from the anti-fraud provider.
            response_status_code:
              type: number
              description: The HTTP response status code from the anti-fraud provider.
            decision:
              type: string
              description: >-
                The parsed decision response from the anti-fraud provider
                response.
              example: ACCEPT
            silent:
              type: boolean
              example: false
              description: >-
                Defines if this service is currently running in silent mode. In
                silent

                mode, a service's decisions will be created but ignored when

                processing a transaction, allowing for warm-up and comparison of
                new

                services against the active service.
    AntiFraudDecisionErrorEvent:
      title: Anti-fraud - Error
      type: object
      description: >-
        This event logs the reason why we were unable to get an anti-fraud
        decision.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: The name of this resource. Is always `anti-fraud-decision-error`.
          example: anti-fraud-decision-error
          enum:
            - anti-fraud-decision-error
        created_at:
          type: string
          description: The date and time when this transaction was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            anti_fraud_service_id:
              type: string
              format: uuid
              description: The unique ID of the anti-fraud service used.
            anti_fraud_service_name:
              type: string
              description: The name of the anti-fraud service used.
            anti_fraud_service_definition_id:
              type: string
              description: The anti-fraud service definition used.
            status_code:
              type: number
              description: >-
                The HTTP response status code from the anti-fraud provider, if
                we received any.
            reason:
              type: string
              description: The reason we could not get the anti-fraud decision.
              example: Network Error
            silent:
              type: boolean
              example: false
              description: >-
                Defines if this service is currently running in silent mode. In
                silent

                mode, a service's decisions will be created but ignored when

                processing a transaction, allowing for warm-up and comparison of
                new

                services against the active service.
    AntiFraudDecisionSkippedEvent:
      title: Anti-fraud - Skipped
      type: object
      description: >-
        This event logs the reason why we skipped getting an anti-fraud
        decision.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: The name of this resource. Is always `anti-fraud-decision-skipped`.
          example: anti-fraud-decision-skipped
          enum:
            - anti-fraud-decision-skipped
        created_at:
          type: string
          description: The date and time when this transaction was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            anti_fraud_service_id:
              type: string
              format: uuid
              description: The unique ID of the anti-fraud service used.
            anti_fraud_service_name:
              type: string
              description: The name of the anti-fraud service used.
            anti_fraud_service_definition_id:
              type: string
              description: The anti-fraud service definition used.
            reason:
              type: string
              description: The reason we could not get the anti-fraud decision.
              example: Missing billing address
            silent:
              type: boolean
              example: false
              description: >-
                Defines if this service is currently running in silent mode. In
                silent

                mode, a service's decisions will be created but ignored when

                processing a transaction, allowing for warm-up and comparison of
                new

                services against the active service.
    AntiFraudDecisionUpdateEvent:
      title: Anti-fraud - Decision update sent
      type: object
      description: >-
        This event logs the request and response details of HTTP calls made to
        an anti-fraud provider to update a pending decision. For example, when
        an anti-fraud review has been rejected.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: The name of this resource. Is always `anti-fraud-decision-update`.
          example: anti-fraud-decision-update
          enum:
            - anti-fraud-decision-update
        created_at:
          type: string
          description: >-
            The date and time when this transaction event was created in our
            system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            anti_fraud_service_id:
              type: string
              format: uuid
              description: The unique ID of the anti-fraud service used.
            anti_fraud_service_name:
              type: string
              description: The name of the anti-fraud service used.
            anti_fraud_service_definition_id:
              type: string
              description: The anti-fraud service definition used.
            anti_fraud_service_check_id:
              type: string
              description: The external ID of the decision.
              example: decision-1234
            decision:
              type: string
              description: The updated decision sent to the anti-fraud provider.
              example: ACCEPT
            request:
              type: string
              description: The HTTP body sent to fetch a decision.
            response:
              type: string
              description: The HTTP body received from the anti-fraud provider.
            response_status_code:
              type: number
              description: The HTTP response status code from the anti-fraud provider.
            silent:
              type: boolean
              example: false
              description: >-
                Defines if this service is currently running in silent mode. In
                silent

                mode, a service's decisions will be created but ignored when

                processing a transaction, allowing for warm-up and comparison of
                new

                services against the active service.
    AntiFraudDecisionUpdateErrorEvent:
      title: Anti-fraud - Decision update failed
      type: object
      description: >-
        This event logs the failure reason when attempting to update the
        decision on the anti-fraud provider.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: >-
            The name of this resource. Is always
            `anti-fraud-decision-update-error`.
          example: anti-fraud-decision-update-error
          enum:
            - anti-fraud-decision-update-error
        created_at:
          type: string
          description: >-
            The date and time when this transaction event was created in our
            system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            anti_fraud_service_id:
              type: string
              format: uuid
              description: The unique ID of the anti-fraud service used.
            anti_fraud_service_name:
              type: string
              description: The name of the anti-fraud service used.
            anti_fraud_service_definition_id:
              type: string
              description: The anti-fraud service definition used.
            anti_fraud_service_check_id:
              type: string
              description: The external ID of the decision.
              example: decision-1234
            decision:
              type: string
              description: The updated decision sent to the anti-fraud provider.
              example: ACCEPT
            reason:
              type: string
              description: The reason we could not update the anti-fraud decision.
              example: Network Error
            silent:
              type: boolean
              example: false
              description: >-
                Defines if this service is currently running in silent mode. In
                silent

                mode, a service's decisions will be created but ignored when

                processing a transaction, allowing for warm-up and comparison of
                new

                services against the active service.
    AntiFraudTransactionStatusUpdateEvent:
      title: Anti-fraud - Transaction update sent
      type: object
      description: >-
        This event logs the request and response details of HTTP calls made to
        an anti-fraud provider to update on a transaction status.  For example,
        when a capture is successful.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: >-
            The name of this resource. Is always
            `anti-fraud-transaction-status-update`.
          example: anti-fraud-transaction-status-update
          enum:
            - anti-fraud-transaction-status-update
        created_at:
          type: string
          description: >-
            The date and time when this transaction event was created in our
            system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            anti_fraud_service_id:
              type: string
              format: uuid
              description: The unique ID of the anti-fraud service used.
            anti_fraud_service_name:
              type: string
              description: The name of the anti-fraud service used.
            anti_fraud_service_definition_id:
              type: string
              description: The anti-fraud service definition used.
            request:
              type: string
              description: The HTTP body sent to fetch a decision.
            response:
              type: string
              description: The HTTP body received from the anti-fraud provider.
            response_status_code:
              type: number
              description: The HTTP response status code from the anti-fraud provider.
            silent:
              type: boolean
              example: false
              description: >-
                Defines if this service is currently running in silent mode. In
                silent

                mode, a service's decisions will be created but ignored when

                processing a transaction, allowing for warm-up and comparison of
                new

                services against the active service.
    AntiFraudTransactionStatusUpdateErrorEvent:
      title: Anti-fraud - Transaction update failed
      type: object
      description: >-
        This event logs the reason why we were unable to update an anti-fraud
        transaction.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: >-
            The name of this resource. Is always
            `anti-fraud-transaction-status-update-error`.
          example: anti-fraud-transaction-status-update-error
          enum:
            - anti-fraud-transaction-status-update-error
        created_at:
          type: string
          description: >-
            The date and time when this transaction event was created in our
            system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            anti_fraud_service_id:
              type: string
              format: uuid
              description: The unique ID of the anti-fraud service used.
            anti_fraud_service_name:
              type: string
              description: The name of the anti-fraud service used.
            anti_fraud_service_definition_id:
              type: string
              description: The anti-fraud service definition used.
            reason:
              type: string
              description: The reason we could not get the anti-fraud decision.
              example: Network Error
            request:
              type: string
              nullable: true
              description: The HTTP body sent to fetch a decision.
            response:
              type: string
              nullable: true
              description: The HTTP body received from the anti-fraud provider.
            response_status_code:
              type: number
              nullable: true
              description: The HTTP response status code from the anti-fraud provider.
            silent:
              type: boolean
              example: false
              description: >-
                Defines if this service is currently running in silent mode. In
                silent

                mode, a service's decisions will be created but ignored when

                processing a transaction, allowing for warm-up and comparison of
                new

                services against the active service.
    AntiFraudWebhookEvent:
      title: Anti-fraud - Webhook
      type: object
      description: >-
        This event logs the webhook received when an anti-fraud decision is
        updated.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: The name of this resource. Is always `anti-fraud-webhook`.
          example: anti-fraud-webhook
          enum:
            - anti-fraud-webhook
        created_at:
          type: string
          description: The date and time when this transaction was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            anti_fraud_service_id:
              type: string
              format: uuid
              description: The unique ID of the anti-fraud service used.
            anti_fraud_service_name:
              type: string
              description: The name of the anti-fraud service used.
            anti_fraud_service_definition_id:
              type: string
              description: The anti-fraud service definition used.
            anti_fraud_service_check_id:
              type: string
              description: The external ID of the decision that's being updated.
              example: decision-1234
            content:
              type: string
              description: The raw payload sent as a webhook.
              example: >-
                { "decision": "ACCEPT", "id": "decision-1234", "reason":
                "Manually verified" }
            content_type:
              type: string
              description: The content type of the payload sent as a webhook.
              example: application/json
            decision:
              type: string
              description: >-
                The parsed decision response from the anti-fraud provider
                webhook.
              example: ACCEPT
            comment:
              type: string
              description: Any comment that may have come with the webhook event.
              example: Manually verified
            silent:
              type: boolean
              example: false
              description: >-
                Defines if this service is currently running in silent mode. In
                silent

                mode, a service's decisions will be created but ignored when

                processing a transaction, allowing for warm-up and comparison of
                new

                services against the active service.
    DigitalWalletApplePayTokenDecrypted:
      title: Digital wallet Apple Pay token decrypted
      type: object
      description: The result after decrypting an Apple Pay token.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: >-
            The name of this resource. Is always
            `digital-wallet-apple-pay-token-decrypted`.
          example: digital-wallet-apple-pay-token-decrypted
          enum:
            - digital-wallet-apple-pay-token-decrypted
        created_at:
          type: string
          description: The date and time when this transaction was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Apple Pay decrypted token context.
          properties:
            version:
              type: string
              description: Version information about the payment token.
              example: EC_v1
            type:
              type: string
              description: The type of payment instrument.
              nullable: true
              enum:
                - dpan
                - fpan
                - null
              example: dpan
            expiration_date:
              type: string
              description: Expiration of the decrypted data.
            has_cryptogram:
              type: boolean
              description: Online payment cryptogram, as defined by 3D Secure.
            eci:
              type: string
              nullable: true
              description: ECI indicator, as defined by 3D Secure.
            application_data:
              type: string
              nullable: true
              description: Hash of the application data property of the original request.
            transaction_identifier:
              type: string
              description: The unique identifier from Apple Pay.
            cardholder_name:
              type: string
              nullable: true
              description: The cardholder name.
            currency_code:
              type: string
              description: ISO 4217 numeric currency code for the transaction.
              example: '840'
            transaction_amount:
              type: integer
              description: The amount for the transaction.
            device_manufacturer_identifier:
              type: string
              description: >-
                Hex-encoded device manufacturer identifier which initiated the
                transaction.
            payment_data_type:
              type: string
              description: Either "3DSecure" or "EMV".
              example: 3DSecure
            merchant_token_identifier:
              type: string
              nullable: true
              description: >-
                For a merchant token request, the provisioned merchant token
                identifier from the payment network.
            card_expiration_date:
              type: string
              nullable: true
              description: Expiration date of card.
            card_suffix:
              type: string
              nullable: true
              description: Last four digits of card PAN.
    DigitalWalletClickToPayTokenDecrypted:
      title: Digital wallet Click to Pay token decrypted
      type: object
      description: The result after decrypting an Click to Pay token.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: >-
            The name of this resource. Is always
            `digital-wallet-click-to-pay-token-decrypted`.
          example: digital-wallet-click-to-pay-token-decrypted
          enum:
            - digital-wallet-click-to-pay-token-decrypted
        created_at:
          type: string
          description: The date and time when this transaction was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Click to Pay decrypted token context.
          properties:
            correlation_id:
              type: string
              description: Correlation ID for transaction.
              example: ba7a2034-3c9e-4d74-b0e9-d77435fd35d7
            merchant_transaction_id:
              type: string
              description: >-
                Merchant Checkout Transaction Identifier which links the
                client-side JavaScript calls and server-side API calls for a
                specific transaction.
              example: 0a4e0d3.34f4a04b.47ee82c373dd4fd5398f3980b39eb6d648b9687c
            type:
              type: string
              description: The type of payment instrument.
              enum:
                - dpan
                - fpan
              example: dpan
            expiration_date:
              type: string
              description: Expiration of the card/token.
            has_cryptogram:
              type: boolean
              description: Online payment cryptogram, as defined by 3-D Secure.
            cardholder_name:
              type: string
              nullable: true
              description: The cardholder name.
            card_bin:
              type: string
              description: First six digits of underlying card.
              example: '424242'
              nullable: true
            card_last_four:
              type: string
              description: Last four digits of underlying card.
              nullable: true
            card_expiration_date:
              type: string
              description: Expiration date of underlying card.
              nullable: true
            card_type:
              type: string
              description: Card type.
              example: CREDIT
              nullable: true
            billing_line1:
              type: string
              nullable: true
              description: Address line 1.
            billing_line2:
              type: string
              nullable: true
              description: Address line 2.
            billing_city:
              type: string
              nullable: true
              description: Address city.
            billing_state:
              type: string
              nullable: true
              description: Address state.
            billing_zip:
              type: string
              nullable: true
              description: Address zip/postal code.
            billing_country_code:
              type: string
              nullable: true
              description: ISO 3166-1 alpha 2 address country code.
    DigitalWalletGooglePayTokenDecrypted:
      title: Digital wallet Google Pay token decrypted
      type: object
      description: The result after decrypting an Google Pay token.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: >-
            The name of this resource. Is always
            `digital-wallet-google-pay-token-decrypted`.
          example: digital-wallet-google-pay-token-decrypted
          enum:
            - digital-wallet-google-pay-token-decrypted
        created_at:
          type: string
          description: The date and time when this transaction was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Google Pay decrypted token context.
          properties:
            version:
              type: string
              description: Version information about the payment token.
              example: ECv2
            type:
              type: string
              description: The type of payment instrument.
              nullable: true
              enum:
                - dpan
                - fpan
                - null
              example: dpan
            expiration_date:
              type: string
              description: Expiration of the decrypted data.
            has_cryptogram:
              type: boolean
              description: Online payment cryptogram, as defined by 3D Secure.
            eci:
              type: string
              nullable: true
              description: ECI indicator, as defined by 3D Secure.
            message_expiration:
              type: string
              description: >-
                Date and time at which the message expires as UTC milliseconds
                since epoch.
            message_id:
              type: string
              description: >-
                A unique ID that identifies the message in case it needs to be
                revoked or located at a later time.
            payment_method:
              type: string
              description: The type of the payment credential.
              example: CARD
    GiftCardRedemptionFailed:
      title: Gift Cards Redemption - Failure
      type: object
      description: >-
        This event logs the request and response details of HTTP calls made to
        redeem gift cards, in case the call failed.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: The name of this resource. Is always `gift-card-redemption-failed`.
          example: gift-card-redemption-failed
          enum:
            - gift-card-redemption-failed
        created_at:
          type: string
          description: The date and time when this event was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            gift_card_service_id:
              type: string
              format: uuid
              description: The unique ID of the Gift Card service used.
            gift_card_service_name:
              type: string
              description: The name of the Gift Card service used.
            gift_card_service_definition_id:
              type: string
              description: The Gift Card service definition used.
            url:
              type: string
              nullable: true
              description: The endpoint for the request, if performed.
            request:
              type: string
              nullable: true
              description: The HTTP body sent to the Gift Card provider, if performed.
            response:
              type: string
              nullable: true
              description: The HTTP body received from the Gift Card provider, if any.
            response_status_code:
              type: number
              nullable: true
              description: >-
                The HTTP response status code from the Gift Card provider, if
                any.
            reason:
              type: string
              description: The reason we could not redeem the gift cards.
              example: Network Error
    GiftCardRedemptionSucceeded:
      title: Gift Cards Redemption - Succeeded
      type: object
      description: >-
        This event logs the request and response details of HTTP calls made to
        redeem gift cards, in case the call succeeded.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: >-
            The name of this resource. Is always
            `gift-card-redemption-succeeded`.
          example: gift-card-redemption-succeeded
          enum:
            - gift-card-redemption-succeeded
        created_at:
          type: string
          description: The date and time when this event was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            gift_card_service_id:
              type: string
              format: uuid
              description: The unique ID of the Gift Card service used.
            gift_card_service_name:
              type: string
              description: The name of the Gift Card service used.
            gift_card_service_definition_id:
              type: string
              description: The Gift Card service definition used.
            url:
              type: string
              nullable: true
              description: The endpoint for the request.
            request:
              type: string
              description: The HTTP body sent to the Gift Card provider.
            response:
              type: string
              description: The HTTP body received from the Gift Card provider.
            response_status_code:
              type: number
              description: The HTTP response status code from the Gift Card provider.
    GiftCardRefundFailed:
      title: Gift Cards Refund - Failed
      type: object
      description: >-
        This event logs the request and response details of HTTP calls made to
        refund gift cards, in case the call failed.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: The name of this resource. Is always `gift-card-refund-failed`.
          example: gift-card-refund-failed
          enum:
            - gift-card-refund-failed
        created_at:
          type: string
          description: The date and time when this event was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            gift_card_service_id:
              type: string
              format: uuid
              description: The unique ID of the Gift Card service used.
            gift_card_service_name:
              type: string
              description: The name of the Gift Card service used.
            gift_card_service_definition_id:
              type: string
              description: The Gift Card service definition used.
            url:
              type: string
              nullable: true
              description: The endpoint for the request, if performed.
            request:
              type: string
              nullable: true
              description: The HTTP body sent to the Gift Card provider, if performed.
            response:
              type: string
              nullable: true
              description: The HTTP body received from the Gift Card provider, if any.
            response_status_code:
              type: number
              nullable: true
              description: >-
                The HTTP response status code from the Gift Card provider, if
                any.
            reason:
              type: string
              description: The reason we could not refund the gift cards.
              example: Network Error
    GiftCardRefundSucceeded:
      title: Gift Cards Refund - Succeeded
      type: object
      description: >-
        This event logs the request and response details of HTTP calls made to
        refund gift cards, in case the call succeeded.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: The name of this resource. Is always `gift-card-refund-succeeded`.
          example: gift-card-refund-succeeded
          enum:
            - gift-card-refund-succeeded
        created_at:
          type: string
          description: The date and time when this event was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            gift_card_service_id:
              type: string
              format: uuid
              description: The unique ID of the Gift Card service used.
            gift_card_service_name:
              type: string
              description: The name of the Gift Card service used.
            gift_card_service_definition_id:
              type: string
              description: The Gift Card service definition used.
            url:
              type: string
              nullable: true
              description: The endpoint for the request.
            request:
              type: string
              description: The HTTP body sent to the Gift Card provider.
            response:
              type: string
              description: The HTTP body received from the Gift Card provider.
            response_status_code:
              type: number
              description: The HTTP response status code from the Gift Card provider.
    NetworkTokenCryptogramProvisionFailed:
      title: Network Token Cryptogram Provision - Failure
      type: object
      description: >-
        This event logs the request and response details of HTTP calls made to
        provision a cryptogram for a network token, in case the call failed.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: >-
            The name of this resource. Is always
            `network-token-cryptogram-provision-failed`.
          example: network-token-cryptogram-provision-failed
          enum:
            - network-token-cryptogram-provision-failed
        created_at:
          type: string
          description: The date and time when this event was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            url:
              type: string
              nullable: true
              description: The endpoint for the request, if performed.
            request:
              type: string
              nullable: true
              description: The HTTP body sent to the Network Token provider, if performed.
            response:
              type: string
              nullable: true
              description: The HTTP body received from the Network Token provider, if any.
            response_status_code:
              type: number
              nullable: true
              description: >-
                The HTTP response status code from the Network Token provider,
                if any.
            reason:
              type: string
              description: The reason we could not provision the cryptogram.
              example: Network Error
    NetworkTokenCryptogramProvisionSucceeded:
      title: Network Token Cryptogram Provision - Succeeded
      type: object
      description: >-
        This event logs the request and response details of HTTP calls made to
        provision a cryptogram for a network token, in case the call succeeded.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: >-
            The name of this resource. Is always
            `network-token-cryptogram-provision-succeeded`.
          example: network-token-cryptogram-provision-succeeded
          enum:
            - network-token-cryptogram-provision-succeeded
        created_at:
          type: string
          description: The date and time when this event was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            url:
              type: string
              description: The endpoint for the request.
            request:
              type: string
              description: The HTTP body sent to the Network Token provider.
            response:
              type: string
              description: The HTTP body received from the Network Token provider.
            response_status_code:
              type: number
              description: The HTTP response status code from the Network Token provider.
    NetworkTokenProvisionFailed:
      title: Network Token Provision - Failure
      type: object
      description: >-
        This event logs the request and response details of HTTP calls made to
        provision a network token, in case the call failed.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: >-
            The name of this resource. Is always
            `network-token-provision-failed`.
          example: network-token-provision-failed
          enum:
            - network-token-provision-failed
        created_at:
          type: string
          description: The date and time when this event was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            url:
              type: string
              nullable: true
              description: The endpoint for the request, if performed.
            request:
              type: string
              nullable: true
              description: The HTTP body sent to the Network Token provider, if performed.
            response:
              type: string
              nullable: true
              description: The HTTP body received from the Network Token provider, if any.
            response_status_code:
              type: number
              nullable: true
              description: >-
                The HTTP response status code from the Network Token provider,
                if any.
            reason:
              type: string
              description: The reason we could not provision the network token.
              example: Network Error
    NetworkTokenProvisionSucceeded:
      title: Network Token Provision - Succeeded
      type: object
      description: >-
        This event logs the request and response details of HTTP calls made to
        provision a network token, in case the call succeeded.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: >-
            The name of this resource. Is always
            `network-token-provision-succeeded`.
          example: network-token-provision-succeeded
          enum:
            - network-token-provision-succeeded
        created_at:
          type: string
          description: The date and time when this event was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            url:
              type: string
              description: The endpoint for the request.
            request:
              type: string
              description: The HTTP body sent to the Network Token provider.
            response:
              type: string
              description: The HTTP body received from the Network Token provider.
            response_status_code:
              type: number
              description: The HTTP response status code from the Network Token provider.
    PaymentConnectorResponseTransactionAuthorizationSucceededEvent:
      title: Authorization
      type: object
      description: >-
        This event logs the exact details parsed details for a succeeded
        authorization

        as reported by our connector.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: >-
            The name of this resource. Is always
            `payment-connector-response-transaction-authorization-succeeded`.
          example: payment-connector-response-transaction-authorization-succeeded
          enum:
            - payment-connector-response-transaction-authorization-succeeded
        created_at:
          type: string
          description: The date and time when this transaction was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            payment_service_id:
              type: string
              format: uuid
              description: The unique ID of the payment service used.
            payment_service_display_name:
              type: string
              description: The display name of the payment service used.
            payment_service_definition_id:
              type: string
              description: The payment service definition used.
            payment_service_transaction_id:
              type: string
              description: >-
                The external ID of the transaction as set by the payment
                service.
              example: transaction-1234
              nullable: true
            status:
              type: string
              enum:
                - authorization_succeeded
              description: |-
                The new status code for the transaction. This is always
                set to `authorization_succeeded`.
              example: authorization_succeeded
            instrument_type:
              type: string
              example: pan
              enum:
                - pan
                - card_token
                - redirect
                - redirect_token
                - googlepay
                - applepay
                - network_token
              description: The type of instrument used for this transaction.
            retry_rule:
              type: string
              description: This will always be `null` because the transaction succeeded.
              example: null
              nullable: true
              deprecated: true
            raw_response_code:
              type: string
              description: >-
                This is the response code received from the payment service.
                This

                can be set to any value and is not standardized across different

                payment services.
              example: incorrect-zip
              nullable: true
            raw_response_description:
              type: string
              description: >-
                This is the response description received from the payment
                service. This

                can be set to any value and is not standardized across different

                payment services.
              example: >-
                The card's postal code is incorrect. Check the card's postal
                code or use a

                different card.
              nullable: true
            auth_response_code:
              description: This is the response description received from the processor.
              example: '00'
              nullable: true
              type: string
            avs_response_code:
              type: string
              description: >-
                The response code received from the payment service for the
                Address

                Verification Check (AVS). This code is mapped to a standardized
                Gr4vy

                AVS response code.


                - `no_match` - neither address or postal code match

                - `match` - both address and postal code match

                - `partial_match_address` - address matches but postal code does
                not

                - `partial_match_postcode` - postal code matches but address
                does not

                - `unavailable ` - AVS is unavailable for card/country


                The value of this field can be `null` if the payment service did
                not

                provide a response.
              example: partial_match_address
              nullable: true
              enum:
                - no_match
                - match
                - partial_match_address
                - partial_match_postcode
                - unavailable
            cvv_response_code:
              type: string
              description: >-
                The response code received from the payment service for the Card

                Verification Value (CVV). This code is mapped to a standardized
                Gr4vy

                CVV response code.


                - `no_match` - the CVV does not match the expected value

                - `match` - the CVV matches the expected value

                - `unavailable ` - CVV check unavailable for card our country

                - `not_provided ` - CVV not provided


                The value of this field can be `null` if the payment service did
                not

                provide a response.
              example: match
              nullable: true
              enum:
                - no_match
                - match
                - unavailable
            payment_method_scheme:
              nullable: true
              description: The card scheme sent to the connector.
              type: string
              example: visa
              enum:
                - accel
                - amex
                - bancontact
                - carte-bancaire
                - cirrus
                - culiance
                - dankort
                - diners-club
                - discover
                - eftpos-australia
                - elo
                - hipercard
                - jcb
                - maestro
                - mastercard
                - mir
                - nyce
                - other
                - pulse
                - rupay
                - star
                - uatp
                - unionpay
                - visa
                - null
    PaymentConnectorResponseTransactionDeclinedEvent:
      title: Authorization - Declined
      type: object
      description: >-
        This event logs the exact details parsed details for a declined
        transaction

        as reported by our connector.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction-event`.
          example: transaction-event
          enum:
            - transaction-event
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this event.
          format: uuid
        name:
          type: string
          description: >-
            The name of this resource. Is always
            `payment-connector-response-transaction-declined`.
          example: payment-connector-response-transaction-declined
          enum:
            - payment-connector-response-transaction-declined
        created_at:
          type: string
          description: The date and time when this transaction was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        context:
          type: object
          description: Additional context for this event.
          properties:
            payment_service_id:
              type: string
              format: uuid
              description: The unique ID of the payment service used.
            payment_service_display_name:
              type: string
              description: The display name of the payment service used.
            payment_service_definition_id:
              type: string
              description: The payment service definition used.
            payment_service_transaction_id:
              type: string
              description: >-
                The external ID of the transaction as set by the payment
                service.
              example: transaction-1234
              nullable: true
            status:
              type: string
              enum:
                - authorization_declined
              description: |-
                The new status code for the transaction. This is always
                set to `authorization_declined`.
              example: authorization_declined
            code:
              type: string
              description: A raw response code returned for the decline.
              example: INVALID DATA
              nullable: true
            instrument_type:
              type: string
              example: pan
              enum:
                - pan
                - card_token
                - redirect
                - redirect_token
                - googlepay
                - applepay
                - network_token
              description: The type of instrument used for this transaction.
            retry_rule:
              type: string
              description: >-
                Defines why the transaction might be retried. A retry is not
                guaranteed because

                the maximum number of retries might already have been attempted.


                * `failure` - the transaction will be retried because of a
                failure calling
                  the payment service.
                * `retriable_decline` - the transaction will be retried because
                a decline code
                  was received that can be retried.
                * `payment_method_replacement` - the transaction will be retried
                because a
                  decline code was received that triggered a payment method replacement.
              enum:
                - failure
                - retriable_decline
                - payment_method_replacement
              example: failure
              nullable: true
            raw_response_code:
              type: string
              description: >-
                This is the response code received from the payment service.
                This

                can be set to any value and is not standardized across different

                payment services.
              example: incorrect-zip
              nullable: true
            raw_response_description:
              type: string
              description: >-
                This is the response description received from the payment
                service. This

                can be set to any value and is not standardized across different

                payment services.
              example: >-
                The card's postal code is incorrect. Check the card's postal
                code or use a

                different card.
              nullable: true
            auth_response_code:
              description: This is the response description received from the processor.
              example: '00'
              nullable: true
              type: string
            avs_response_code:
              type: string
              description: >-
                The response code received from the payment service for the
                Address

                Verification Check (AVS). This code is mapped to a standardized
                Gr4vy

                AVS response code.


                - `no_match` - neither address or postal code match

                - `match` - both address and postal code match

                - `partial_match_address` - address matches but postal code does
                not

                - `partial_match_postcode` - postal code matches but address
                does not

                - `unavailable ` - AVS is unavailable for card/country


                The value of this field can be `null` if the payment service did
                not

[...]
